// Pingo, a color clock
//
// A totally new way of telling time
// By Illusionmanager. 
// 2023
//
// if you like it, please follow him on youtube as he is trying the reach the magical 1000 youtube number
// https://www.youtube.com/@illusionmanager
// where you can see all kind of things he makes.
//
#define PINGO "       Pingo Color Clock\n\n       by illusionmanager\n (youtube.com/@illusionmanager)\n\n"
#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
    #include <avr/power.h> // Required for 16 MHz Adafruit Trinket
#endif

#include <ESPAsyncTCP.h>
#include <ESPAsyncWebSrv.h>

#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <Schedule.h>
#include <time.h>  
#include <TZ.h>
#include <String.h>
#include <Preferences.h>

// set BROKEN to zero if you connect all the rings together
// Mine was broken so I missed 24 led and ring[4] is skipped in the wiring
// the program never uses ring[4]


#define BROKEN 24
#define NUM_LEDS (241-BROKEN)
#define DATA_PIN D2
// edit this to match your local WiFi:
#define MYSSID "YOUR_NETWORK_NAME"
#define MYPASSKEY "YOUR_NETWORK_PASSWORD"

// max brightness of 100 gives a max power consumption well below 1A and at
// a value of 255 the max power consumption stays below 1.5A with the current animations.
// To stay below 0.5A, set this to 40
// it is totally fine compile this with a value of 255, and I think you should
// after your are done programming Pingo, but if you do,
// set and save the brightness to minimum before connecting Pingo to your PC
// or even better, disconnect the jumper wire from the VU pin on the controller
// otherwise you could damage your PC by using too much power from the usb port.
#define MAXBRIGHTNESS 40

// pick timezone from TZ.h
#define TIMEZONE TZ_Europe_Amsterdam

// your location, for sunrise/sunset.
#define LATITUDE "53.25"
#define LONGITUDE "6.75"
// api key to get info from openweathermap.org
// there is a maximum request rate, so if it stops working
// request your own free key.
#define APIKEY "931e6527b0c2f101cfc8946d327f4193"

#define WIFI_ANIM

Preferences preferences; // used to store value in NVM

time_t sunrise = 0;
time_t sunset = 0;
int sun_done = 0;
int sun_tries = 0;
int clockstyle = 0;
int brightness = 20; // 20 is save max for computer usb port, max 109 to keep power consumption below 2A (using usb power brick)
int time_offset =0; // just for debugging and playing around
int hour = 0;
int minute = 0;
int second = 0;
int night_brightness = 34; // percentage to dim the lights between sunset and sunrise
int b_value = 100;
int prev_b_value = -1;
int wifi_anim =1;
const int ringsize[9] = {1,8,12,16,24,32,40,48,60};
int ring[9];
int alarm = -1; // 2312 would be 23:12,  -1 would turn the alarm off;

// this client part is from some example code some one posted, which I adapted (badly ;-) )
static AsyncClient *aClient = NULL;

void runAsyncClient(){
  if(aClient) return; //client already exists
  aClient = new AsyncClient();
  if(!aClient) return; //could not allocate client
  aClient->onError([](void *arg, AsyncClient *client, int error){
    Serial.println("Connect Error");
    aClient = NULL;
    delete client;
  }, NULL);

  aClient->onConnect([](void *arg, AsyncClient *client){
    aClient->onError(NULL, NULL);
    client->onDisconnect([](void *arg, AsyncClient *c){
      aClient = NULL;
      delete c;
    }, NULL);
    client->onData([](void *arg, AsyncClient *c, void *data, size_t len) {
      // this code won't work when the data for sunrise/sunset is split into data chunks!!
      // it expects something like "sunrise":1676098803,"sunset":1676133274}
      char * d = (char*)data;
      if (len>0) d[len]=0;
      char *p = strstr(d,"\"sunrise\"");
      if (p != NULL) {
        p+=10;
        sunrise=0;        
        while (isDigit(*p)) sunrise = sunrise * 10 + *p++ - '0';
        sunset = 0;
        p+=10;
        while (isDigit(*p)) sunset = sunset * 10 + *p++ - '0';
        sun_done = 1;
        Serial.println("Answer from openwheathermap.org:");
        Serial.printf("sunrise %s",ctime(&sunrise));
        Serial.printf("sunset %s",ctime(&sunset));
        }
    }, NULL);
    char req[100];
    snprintf(req,100,"GET /data/2.5/weather?lon=%s&lat=%s&APPID=%s HTTP/1.0\r\n\r\n\0",
       LONGITUDE, LATITUDE, APIKEY);
    client->write(req); //send this request
  }, NULL);
  if(!aClient->connect("api.openweathermap.org", 80)){
    Serial.println("Connect Fail");
    AsyncClient *client = aClient;
    aClient = NULL;
    delete client;
  }
}

static esp8266::polledTimeout::periodicMs update(20);

// the rainbow function from adafruit, can only fill complete strip from the begining.
// pinto needs only a partial fill, so that method is added to MyPixel;
class MyPixel : public Adafruit_NeoPixel {
    public: 
    MyPixel(uint16_t n, int16_t pin = 6, neoPixelType type = NEO_GRB + NEO_KHZ800) : Adafruit_NeoPixel(n,pin,type) {
        ;
    }
    void rainbow(uint16_t starthue, uint16_t first, uint16_t num) {
        for (uint16_t i=0; i<num; i++) {
            uint16_t hue = starthue + (i * 65536) / num;
            uint32_t color = this->ColorHSV(hue, 255, 128);
            this->setPixelColor(i+first, color);
        }
    }
};

MyPixel leds(NUM_LEDS, DATA_PIN, NEO_GRB + NEO_KHZ800);

AsyncWebServer server(80);

void notFound(AsyncWebServerRequest *request) {
    request->send(404, "text/plain", PINGO);
}


time_t now ;
void setup() {
    now = time(nullptr);
    WiFi.persistent(false);
    WiFi.mode(WIFI_OFF);
    Serial.begin(74880);
    Serial.print("\nPingo Clock Starting in 3..");
    delay(1000);
    Serial.print("2..");
    delay(1000);
    Serial.println("1..\n");
    // read some preverences from NVM
    preferences.begin("pingo",true);
    clockstyle = preferences.getInt("style",0);
    brightness = preferences.getInt("bright",20);
    night_brightness = preferences.getInt("night",34);
    time_offset = preferences.getInt("time",0);
    alarm = preferences.getInt("alarm",-1);
    preferences.end();
    configTime(TIMEZONE, "pool.ntp.org");
    yield();
    leds.begin();
    leds.clear();
    leds.setBrightness(brightness);
    leds.show();
    ring[0] = 0;
    ring[1] = ring[0]+ringsize[0];
    ring[2] = ring[1]+ringsize[1];
    ring[3] = ring[2]+ringsize[2];
    ring[4] = ring[3]+ringsize[3];
    ring[5] = ring[4]+ringsize[4] - BROKEN;
    ring[6] = ring[5]+ringsize[5];
    ring[7] = ring[6]+ringsize[6];
    ring[8] = ring[7]+ringsize[7];
    
    // start network
    WiFi.mode(WIFI_STA);
    WiFi.begin(MYSSID, MYPASSKEY);
    leds.clear();
    leds.fill(0x1010f0,ring[0],ringsize[0]);
    leds.fill(0x1010f0,ring[1],ringsize[1]);
#ifdef WIFI_ANIM 
    leds.show();
    delay(3000); // somehow this delay prevents a stutter
#endif
    int cnt = 0;
    while ( WiFi.status() != WL_CONNECTED || cnt++ < 5) {         
#ifdef WIFI_ANIM
        // little animation of a WiFi symbol
        leds.fill(0x1010f0,ring[0],ringsize[0]);
        leds.fill(0x1010f0,ring[1],ringsize[1]);
        leds.show(); delay(200);
        leds.fill(0x1010f0,ring[3],ringsize[3]/4);
        leds.show(); delay(200);
        leds.fill(0x000000,ring[3],ringsize[3]/4);
        leds.fill(0x1010f0,ring[5],ringsize[5]/4);
        leds.show(); delay(200);
        leds.fill(0x000000,ring[5],ringsize[5]/4);
        leds.fill(0x1010f0,ring[7],ringsize[7]/4);
        leds.show(); delay(200);
        leds.fill(0x000000,ring[7],ringsize[7]/4);
        leds.show();
#endif
        yield();
    }  
    
    leds.clear();
    Serial.println(PINGO);
    Serial.println("\nAccess settings like this from your web browser:\n");
    Serial.print(WiFi.localIP());
    Serial.printf("/pingo\n\n");
    server.onNotFound(notFound);
    server.on("/pingo", HTTP_GET, [](AsyncWebServerRequest *request) {
        if (request->hasParam("night_brightness")) {
            // the percentage of which to dim the clock between sunset and sunrise;
            night_brightness = (request->getParam("night_brightness")->value().toInt()) ;
        }
        if (request->hasParam("style")) {
            clockstyle = (request->getParam("style")->value().toInt());
        }
        if (request->hasParam("brightness")) {
            brightness = (request->getParam("brightness")->value().toInt());
            if (brightness < 16) brightness = 16;
            if (brightness > MAXBRIGHTNESS) brightness = MAXBRIGHTNESS;
            leds.setBrightness((brightness*b_value)/100);
            
        }
        if (request->hasParam("time")) {
            time_offset = (request->getParam("time")->value().toInt()); 
            now = time(nullptr) + time_offset;
        }
        if (request->hasParam("alarm")) {
            // needs fixing !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            String al = (request->getParam("alarm")->value());
            if (al.length()==0) {
                alarm = -1;
            } else {
                alarm = (al.substring(0,2)).toInt() *100 + (al.substring(3,5)).toInt();
            }
            Serial.printf("alarm %d\n", alarm); 
        } 
        if (request->hasParam("save")) {
            int save_needed = (request->getParam("save")->value().toInt());    
            if (save_needed) {
                preferences.begin("pingo",false);
                preferences.putInt("style", clockstyle);
                preferences.putInt("bright", brightness);
                preferences.putInt("night", night_brightness);
                preferences.putInt("time", time_offset);
                preferences.putInt("alarm", alarm);
                preferences.end(); 
                save_needed = 0;
            }
      }
        char answer[2350];
        char alarms[6];
        if (alarm <0) {
            strcpy(alarms,"--:--");
        } else {
            sprintf(alarms,"%02d:%02d",alarm / 100, alarm %100);
        }
        int s = clockstyle;
        // magical string that makes a good looking website for pingo
        snprintf(answer,2350,"<head><title>Pingo</title><style>body{font-family: \"Empanada\", Helvetica, Sans-serif; font-size: 40px;\
            text-align: center; background-color: lightyellow;}input{color: white; background-color: #7aa8b7; ; font-size: 40px; }\
            .lnk {display: inline-block;padding: 10px 20px;text-align: center;text-decoration: none;color: #ffffff;background-color:\
            #7aa8b7;border-radius: 7px; box-sizing: border-box;width: 200px; height: 60px;transition-duration:0.7s;}\
            .lnk1:hover {background-color: #918B30} .lnk1 {background-color:#7aa8b7} .lnk2 {background-color:#B8978D }</style></head>\n\
            <h1>Pingo</h1><p>Color Clock by illusionmanager</p><h6>%s</h6><p>\n\
            <a class=\"lnk lnk%d\" href=\"/pingo?style=0\">pingo</a>\n<a class=\"lnk lnk%d\" href=\"/pingo?style=1\">ticky</a>\n\
            <a class=\"lnk lnk%d\" href=\"/pingo?style=2\">static</a><br><br>\n<a class=\"lnk lnk%d\" href=\"/pingo?style=3\">frantic</a>\n\
            <a class=\"lnk lnk%d\" href=\"/pingo?style=4\">blinky</a>\n<a class=\"lnk lnk%d\" href=\"/pingo?style=-1\">minimal</a><br><br>\n\
            <a class=\"lnk lnk%d\" href=\"/pingo?style=-2\">ringed</a>\n<a class=\"lnk lnk%d\" href=\"/pingo?style=-3\">modern</a>\n\
            <a class=\"lnk lnk%d\" href=\"/pingo?style=-4\">classic</a><br><br>\n</p><p>\n\
            <form style=\"color: #E2948E\" action=\"/pingo\" method=\"get\">Alarm<br>\n<input style=\"border-radius: 7px;outline: none;\
            box-sizing: border-box; width:200px;height:60px;text-align: center;\" type=\"time\" name=\"alarm\" value=\"%s\"><br><br>\n\
            Brightness <br><input type=\"range\" min=\"20\" max=\"%d\" name=\"brightness\" value=\"%d\" ><br><br>\n</form></p>\n\
            <a class=\"lnk lnk1\" href=\"/pingo?save=1\">save</a>\n\
            <script>\nconst myForm = document.querySelector('form');\nconst myRangeInput = document.querySelector('input[type=\"range\"]');\n\
            const myAlarmInput = document.querySelector('input[type=\"time\"]');myAlarmInput.addEventListener('keydown', function(event) {\n\
            if (event.key =='Enter') {myChangeHandler(event);}});\n\
            myRangeInput.addEventListener('change', myChangeHandler);\nfunction myChangeHandler(event) {myForm.submit();}\n</script>",
            ctime(&now),s==0?2:1,s==1?2:1,s==2?2:1,s==3?2:1,s==4?2:1,s==-1?2:1,s==-2?2:1,s==-3?2:1,s==-4?2:1,alarms,MAXBRIGHTNESS,brightness);
        request->send(200, "text/html",answer);
    });
    server.begin();
    runAsyncClient();
    delay(2000);
    leds.clear();
    leds.setBrightness(0);
#ifdef WIFI_ANIM
    leds.show();
#endif 
}

void addtickmarks(int color) {
    for (int i = 0; i < 12; i++) {
        //if (i*5 != minute || clockstyle >=0 ) {
            leds.setPixelColor(ring[8]+ringsize[8]*i/12, color);
        //} 
        leds.setPixelColor(ring[7]+ringsize[7]*i/12, color);
        if (clockstyle < 0) {
            leds.setPixelColor(ring[6]+(ringsize[6]*i)/12.0+0.5, color);
        }
    }     
}

void addseconds(int color) {
    int newcolor = 0;
    int oldcolor = leds.getPixelColor(ring[8]+second);
    if (color) 
        newcolor = oldcolor | color;
    leds.setPixelColor(ring[8]+second, newcolor);
    if (clockstyle >=0 ) { // make the second spot bigger
        oldcolor = leds.getPixelColor(ring[8]+(second+1)%60);
        newcolor = 0;
        if (color) { newcolor = oldcolor | color; }
        leds.setPixelColor(ring[8]+(second+1)%60, newcolor);
        oldcolor = leds.getPixelColor(ring[7]+(second+1)*ringsize[7]/60.0);
        if (color) { newcolor = oldcolor | color; }
        leds.setPixelColor(ring[7]+(second+1)*ringsize[7]/60.0, newcolor);
    } 
}

void traditional_style() {
    int oldcolor;
    oldcolor = leds.getPixelColor(ring[7]+(hour % 12) * ringsize[7] / 12.0+0.5 + (minute*ringsize[6])/720.0);
    leds.setPixelColor(ring[7]+(hour % 12) * ringsize[7] / 12.0+0.5 + (minute*ringsize[7])/720.0,oldcolor | 0xffff00);
    oldcolor = leds.getPixelColor(ring[6]+(hour % 12) * ringsize[6] / 12.0+0.5 + (minute*ringsize[6])/720.0);
    leds.setPixelColor(ring[6]+(hour % 12) * ringsize[6] / 12.0+0.5 + (minute*ringsize[6])/720.0,oldcolor | 0xffff00);
    oldcolor = leds.getPixelColor(ring[8]+minute);
    leds.setPixelColor(ring[8]+minute,oldcolor | 0xff0000);
    oldcolor = leds.getPixelColor(ring[7]+minute * ringsize[7] / 60.0 +0.5);
    leds.setPixelColor(ring[7]+minute * ringsize[7] / 60.0 + 0.5, oldcolor |= 0xff0000);
    
}

void pingo_style(uint16_t hue_hour, int16_t hue_minute, uint16_t hue_extra) {
        // pingo_style uses a max brightness of 180 instead of 128, to match with traditional style
        leds.fill(leds.ColorHSV(hue_minute + hue_extra,255,128), ring[7], ringsize[7]+ringsize[8]);
        leds.rainbow(hue_extra,ring[6],ringsize[6]);
        leds.rainbow(hue_extra,ring[5],ringsize[5]);
        leds.fill(leds.ColorHSV(hue_hour + hue_extra,255,128), ring[0], ringsize[0]+ringsize[1]+ringsize[2]+ringsize[3]);
}

void loop() {
    static int milli_offset = 0;
    static int prevsecond = -1;
    uint16_t hue_offset = 0;
    if (update ) {
      now = time(nullptr);
      int milli = millis();
      now += time_offset;
      char timebuf[26];
      strcpy(timebuf,ctime(&now));
      hour = ((timebuf[11]-'0')*10 + timebuf[12]-'0');
      minute = (timebuf[14]-'0')*10 + timebuf[15]-'0';
      second = (timebuf[17]-'0')*10 + timebuf[18]-'0';  
      if (second != prevsecond) {
          milli_offset = milli;
          prevsecond = second;
      }
      if (hour == 3 && minute == 00 && sun_done) {
        // trigger for start reading sunrise/sunset data from server 
        sun_done =0;
        sun_tries = 0;
      }
      // try max 10 times getting the sunrise/sunset values from openweathermap.org
      if (aClient == NULL && sun_done == 0 && sun_tries <10 && minute %10 == 1 && second == 0) {
        runAsyncClient(); // starts a asynchronous client to fetch the sunrise/sunset data 
        if (sun_tries >0) delay(1000);      
        sun_tries++;
      }
      uint16_t h_offset = 0;
      if (now <= sunrise - 3600) {
          h_offset = -90;
          b_value = night_brightness; 
      } else if (now <= sunrise + 3600) {
          h_offset = -90 + ((90+60) * (sunrise+3600-now)) / 7200;
          b_value = night_brightness + ((100-night_brightness) * (sunrise +3600 - now)) / 7200;
      } else if (now <= sunset - 3600) {
          h_offset = 60;   
          b_value = 100;         
      } else if ( now <= sunset + 3600) {
          h_offset = -90 + ((90+60) * (sunset+3600-now)) / 7200;
          b_value = night_brightness + ((100-night_brightness) * (sunset + 3600 - now)) / 7200;
      } else {
          h_offset = -90/360 * 65536;
          b_value = night_brightness; 
      }
      hue_offset = (65536 * h_offset) / 360 - (65536 * minute)/60 - (65536 * second) / 3600;
      uint16_t hue_minute = (minute * 65536) / 60 + (second *65536) / 3600;
      uint16_t hue_hour = ((hour % 12) *65536)/12 + (minute * 65536) / 720;
      if (b_value != prev_b_value) {
          leds.setBrightness((brightness*b_value)/100);
          leds.show();
          prev_b_value = b_value;
      }
      if (hour == (alarm / 100 ) && (minute == alarm % 100) ) {
          // flash in red
          leds.clear();
          if (second & 1) {
              leds.fill(0xff0000, 0, NUM_LEDS);
          }
      } else {
          switch (clockstyle) {
          // if you start building your own, you might want to reduce MAXBRIGHTNESS because
          // the powerconsumption is based on the fact that currently it never happens that
          // all leds are full brightness.
          case -1:
              leds.clear();
              traditional_style();
              leds.fill(0x505050,ring[0], ringsize[0]+ringsize[1]);
              break;
          case -2:
              leds.clear();
              leds.fill(0x202020,ring[8], ringsize[8]);
              traditional_style();
              addseconds(0xffffff);
              leds.fill(leds.ColorHSV(hue_hour), ring[0], ringsize[0]+ringsize[1]);
              break;
          case -3:
              leds.clear();
              leds.fill(0x102020,ring[8], ringsize[8]);
              addtickmarks(0x404040);
              traditional_style();
              addseconds(0x00ff00);
              break;
          case -4:
              leds.clear();
              addtickmarks(0x282814);
              traditional_style();
              addseconds(0x0000ff);
              leds.fill(0x282814,ring[0], ringsize[0]+ringsize[1]);
              break;
          case 1:
              leds.clear();
              pingo_style(hue_hour, hue_minute, hue_offset);
              addtickmarks(0x000000);
              addseconds(0x000000);
              break;
          case 2:
              leds.clear();
              pingo_style(hue_hour, hue_minute, 11000);
              addtickmarks(0x000000);
              addseconds(0xffffff);
              break;
          case 3:
              leds.clear();
              pingo_style(hue_hour, hue_minute, (second + (milli - milli_offset) / 1000.0) * 65536 *2 / 60);    
              break;
          case 4:
              leds.clear();
              pingo_style(hue_hour, hue_minute, hue_offset);
              if (second & 1 ) {
                  leds.fill(0, ring[0], ringsize[0]+ringsize[1]);
              }
              break;
          default:
              leds.clear();
              pingo_style(hue_hour, hue_minute, hue_offset);
              addseconds(0x000000);
              break;
          }
      }
      leds.show();
    }
}
